//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "killbrothers.h"

#define FIFO "/var/www/tmp/fifo-out"
#define FIFO_DATA "/var/www/tmp/fifo-data"
#define FIFO_CMD "/var/www/tmp/fifo-in"

int fdata, fcmd, tmp=0;
char data[256];

char cmdread(char* d){
	char ret = 0;
	struct timeval tv;
	fd_set rfds;
	FD_ZERO(&rfds);
	FD_SET(fcmd, &rfds);
	tv.tv_sec=0; tv.tv_usec=300000; 
	if(select(fcmd+1, &rfds, NULL, NULL, &tv) > 0)
		if(FD_ISSET(fcmd, &rfds))
		    if(read(fcmd, d, 250) > 0)
			ret = 1;
	return ret;
}

char dataread(char* d){
	char ret = 0;
	struct timeval tv;
	fd_set rfds;
	FD_ZERO(&rfds);
	FD_SET(fdata, &rfds);
	tv.tv_sec=0; tv.tv_usec=300000; 
	if(select(fdata+1, &rfds, NULL, NULL, &tv) > 0)
		if(FD_ISSET(fdata, &rfds))
		    if(read(fdata, d, 250) > 0)
			ret = 1;
	return ret;
}

int main(){
	int cntr;
	killbrothers();
	umask(0);
	mkfifo(FIFO_DATA, 0666); //  ,    
	mkfifo(FIFO_CMD, 0666);
	fcmd = open(FIFO_CMD, O_RDWR);
	if(fcmd<1){printf("err2\n"); exit(1);}
	fdata = open(FIFO_DATA, O_RDWR);
	if(fdata<1){printf("err1\n"); exit(1);}
	//setbuf(fdopen(fcmd, "r+"), NULL); //   
	//setbuf(fdopen(fdata, "r+"), NULL); //   
	setbuf(stdout, NULL);
	printf("Content-type:  multipart/x-mixed-replace; boundary=myboundary\r\n\n");
	for(cntr = 0; cntr < 30; cntr ++){ //    - 30 
		if(cmdread(data)){		
			printf("Content-type: text/html\r\n\n");
			printf("<html>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=koi8-r\">\n");
			printf("<link rel=\"stylesheet\" href=\"/style.css\" type=\"text/css\">\n");
			printf("<body>\n<h1> :</h1><div id=middle><pre>\n");
			printf("cmd1: %s\n", data);
			if(dataread(data)) printf("data1: %s\n", data);
			usleep(10);
			if(cmdread(data)) printf("\ncmd2: %s\n", data);
			if(dataread(data)) printf("data2: %s\n", data);
				printf("<div id=\"bottext\">timings: %d</div>\n", cntr);
				printf("</pre></div></body></html>\n");
				printf("--myboundary\n");
			}
	}
	printf("Content-type: text/html\r\n\n"); //   30      
			// (  ,   )
	printf("<meta http-equiv=\"refresh\" content=0>\n");
	printf("--myboundary\r\n");
	close(fdata);
	close(fcmd);
}
