//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include "killbrothers.h"
#define PROC_BASE "/proc"

int readname(char *name, pid_t pid){ //     /proc/...
	char path[256], nm[512], *ptr;
	int file;
	sprintf (path, PROC_BASE "/%d/cmdline", pid);
	if((file = open(path, O_RDONLY)) < 0){return 0;}
	if(read(file, nm, 512) < 1){return 0;}
	if((ptr = strrchr(nm, '/')))
		strncpy(name, ptr+1, (int)(nm-ptr+512));
	else
		strncpy(name, nm, 511);
	close(file);
	return 1;
}

int killbrothers(){
	DIR *dir;
	struct dirent *de;
	int ret = 0;
	pid_t pid, self;
	char name[512], myname[512];
	if (!(dir = opendir (PROC_BASE))){ //   /proc
		perror(PROC_BASE);
		return -1;
	}
	self = getpid(); //  
	if(!readname(myname, self)) return -1; //   
	while ((de = readdir (dir)) != NULL){ //      
	// ,      ,    self
		if (!(pid = (pid_t) atoi (de->d_name)) || pid == self)
			continue;
		if(!readname(name, pid)) continue; //   
		if(strncmp(name, myname, 511) == 0){ //     self
//			if(kill(pid, SIGTERM) != 0) ret = 0; //   
//			else 
				ret = 1;
		}
	}
//	if(ret == 1)sleep(3); // ,     
	closedir(dir);
	return ret;
}
