#ifndef _QUEUES_H_
#define _QUEUES_H_
#include <stdio.h>		//  /
#include <stdlib.h>		// atoi, calloc   . 
#include <fcntl.h>		//  O_...
#include <sys/stat.h>	//  
#include <sys/types.h>	// getpid()
#include <mqueue.h>		//  
#include <unistd.h>		// getopt
#include <string.h>		//  
#include <time.h>
#define PRIO_ERR	100	//     
#define PRIO_MSG	1

time_t t_;
struct tm* tm_;

#define warn(...)  do{int n = 0; if(mq_out > 0 && out_buf){ t_ = time(NULL); tm_ = localtime(&t_); \
		n = strftime(out_buf, mq_size, "%H:%M:%S, ", tm_); \
		mq_send(mq_out, out_buf, n, PRIO_MSG); \
		n = snprintf(out_buf, mq_size, __VA_ARGS__); \
		mq_send(mq_out, out_buf, n, PRIO_MSG);}else fprintf(stderr,"No mq_out\n");}while(0)
#define err(...)  do{fprintf(stderr,__VA_ARGS__);fputc('\n',stderr); \
		warn(__VA_ARGS__);}while(0)
#define die(...)   do{fprintf(stderr, __VA_ARGS__); quit(0);}while(0)

// compile: gcc -lrt ...

#define CMD_QUEUE "/input-IFACE"
#define OUT_QUEUE "/output-IFACE"

int	c, flags, i, nfds;
extern mqd_t mq_cmd, mq_out;
extern ssize_t mq_size;
extern char *in_buf, *out_buf;
struct mq_attr	attr;

char* get_qs(char* buf, int l);
int get_qs_param(char *param, char *meaning, int l);
void mk_queues();
void rm_queues();
int read_queue(unsigned char *cno, unsigned char *cmd, char *value);
#endif // _QUEUES_H_

