//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

/*
 *	        :
 *	NO_ECHO -     (init  ,    
 *		    )
 *	NOT_ADD_STEPS -         
 *		      (init   )
 */

#include	<pic16f870.h>
#include "main.h"
//#define CLRWDT	_asm clrwdt _endasm;
typedef unsigned int word;
word at 0x2007 CONFIG = 0x3F72; //  WDT: 0x3F76
unsigned char pos, //   
	cmd, //      
	voltage, //  
	mC_addr, // .   (,   init)
	terminal_stops_motor,  //     
	terminal_flag, //   
	isstep, //  -  
	block, //      ,     
	TMR_H, TMR_L, //    1 
	d_H, d_L, //    getword
	mode_mask, stop_mask, stop_mask2, //     / 
	stop_bits, stop_bits2, //      
	async_msgs, //    ?
	echo,		// 1 -    , 0 - 
	s_add;		// 1 -      , 0 -  
char dir_glob = 1, dir_before_term = 0; //   ( /  )
char term_send = 1; //     
unsigned int steps = 0, // - ,     
	total_steps = 0; // -  

const unsigned char phase[] = {0x04, 0x00, 0x01, 0x02, 0x06, 0x0A, 0x09, 0x08}; //   

const unsigned char dpmconf[] = {0xFC, 0x00,  //1    (  ),   - AND,  - OR
	0xFC, 0x02, // 1
	0xF3, 0x00, // 2
	0xF3, 0x08, // 2
	0xF0, 0x00, // 12
	0xF0, 0x08, // 12
	0xF0, 0x02, // 12
	0xF0, 0x0A, // 12
	0xFC, 0x01, // 1
	0xF3, 0x04, // 2
	0xF0, 0x05 // 12
	}; //FC - 1, F3 - 2, F0 - 

void set_voltage(unsigned char V){	//   
	unsigned char tmp = PORTC;
	tmp &= 0xF8; //   3  
	tmp |= V;  
	PORTC = tmp; //   
}	

void change_voltage(unsigned char V){
	unsigned char tmp = PORTC;
	voltage = V;
	if((tmp & 0x07) != 0){//     
		tmp &= 0xF8; //   3  
		tmp |= V;  
		PORTC = tmp; //  	
	}
}

void step(char dir){ //   
	unsigned char tmp = PORTA & 0xF0;
	pos+=dir; pos &= 0x07; //     
	PORTA = tmp | phase[pos]; //  . 
	total_steps ++; //  ()   
}

void dpm(char dir){
	unsigned char tmp = PORTA;
	tmp &= dpmconf[dir]; // 
	PORTA = tmp | dpmconf[dir+1]; //   
	if(dir != 20) set_voltage(voltage); //  
	else set_voltage(block); //   
}

void send9bit(unsigned char something){
	unsigned char tmp;
	something &= 0x1F; //     (  )
	tmp = mC_addr | something;
	TXEN = 1; //   
	TX9D = 0; // 0 -  
	TXREG = tmp;	//  
}

unsigned char get9bit(){
	unsigned char err1, err2, flag9bit, tmp;
	while(!RCIF);
	flag9bit = RX9D;
	err1 = FERR; err2 = OERR; //  9-   
	cmd = RCREG; //   
	RX9D = 0;
	if(err1 & echo){
		send9bit(NO_STOP_BIT); //    
		return NO_STOP_BIT;
	}
	if(err2){
		if(echo) send9bit(STACK_OVERFLOW); //   
		CREN = 0; CREN = 1; //   
		return STACK_OVERFLOW;
	}
	if(flag9bit) return TWOBYTE; //  -    (   :) )
	tmp = cmd & 0xE0; //    
	cmd &= 0x1F; //   
	if(tmp != mC_addr) return ERR_CMD; //   
	if(echo) send9bit(cmd); //   
	return OK;
}

void sendword(unsigned char data_H, unsigned char data_L){
	RCIE = 0; // disable USART in interrupt
	TMR1IE = 0;
	TXEN = 1;
	TX9D = 1;
	TXREG = data_H;
	while(!TRMT);
	TXEN = 1;
	TX9D = 1;
	TXREG = data_L;
	RCIE = 1;
	TMR1IE = 1;
}

unsigned char getword(){
	unsigned char ret = 0;
	RCIE = 0; // disable USART in interrupt
	TMR1IE = 0;
	if(ten_times_read()){
		d_H = cmd;
		if(ten_times_read()){
			d_L = cmd;
			ret = 1;}} //     
	TMR1IE = 1;
	RCIE = 1; // enable USART in interrupt
	return ret;
}

unsigned char ten_times_read(){ // 10     
	unsigned char i=0;
	do i++;
	while(get9bit() != TWOBYTE && i < 10);
	if(i > 9 && echo){send9bit(ERR_CMD); return 0;}
	if(echo) send9bit(OK);
	return 1; 
}

void init(){ // 
//  USART'a
// TXSTA: | CSRC | TX9 | TXEN | SYNC | N/A | BRGH | TRMT | TX9D |
	TXSTA = 0x66; // (11000110): master, 9-  /, async, hi-speed, ready
// SPBRG -  
	SPBRG = 12; // 19.2 /
// RCSTA: | SPEN | RX9 | SREN | CREN | ADDEN | FERR | OERR | RX9D |
	RCSTA = 0xD0; // ( 11010000): enable, 9bit, continuous mode
//  :
	PORTA = 0; // 6-  /  (0..5 )
// ADCON1: | ADFM | N/A | N/A | N/A | PCFG3 | PCFG2 | PCFG1 | PCFG0 |
	ADCON1 = 0x06; // /      
	TRISA = 0; //    (1-, 0-) 
	TRISB = 0xff; //           --/ B /--
// OPTION_REG: | !RBPU | INTEDG | TOCS | TOSE | PSA | PS2 | PS1 | PS0 |
	OPTION_REG = 0x7f; /* (01111111) 0 -     B (. . 1),
				    RB0,
				 0     RA4
				 0      RA4
				    
				 prescaler:  1:128 */ 
	TRISC = 0xC0; // (1100000) - 0..5   
	INTCON = 0; //   
// PIE1: | PSPIE | ADIE | RCIE | TXIE | N/A | CCP1IE | TMR2IE | TMR1IE |
	PIE1 = 0x21; // (00100001): enable USART(in) & TIMER1 interrupt
// PIE2:  N/A,  EEIE (PIE2.4)
	PIE2 = 0; //                & disable other int.s
	PORTB = 0;
// INTCON: | GIE | PEIE | T0IE | INTE | RBIE | T0IF | INTF | RBIF |
	INTCON = 0xC0; // (1100000) -   ,   
//PORTC &= 0xF8; // (11111000) -  
	PORTC = 0; //  
	PORTA = 0xF; // (00001111)
//  
	mC_addr = PORTB; //   
	mC_addr &= 0xE0; //    
//  
	pos = 0;
//	test_flag = 0;
	terminal_flag = 0;
	terminal_stops_motor = 0;
	block = 0;
	isstep = 0;
	TMR_H = 0;
	TMR_L = 0;
	voltage = NINE;
	async_msgs = 0;
	echo = 1;
	s_add = 1;
	timer1set(ON);
}

void timer1set(unsigned char on_off){ //  
	T1CON = 0; //  
	TMR1IF = 0; //   
	TMR1IE = on_off; // / 
//	CLRWDT
	if(on_off == OFF) return; //    
	TMR1H = TMR_H; TMR1L = TMR_L;  //  
// T1CON: | - | - | T1CPS1 | T1CPS0 | T1OSCEN | T1SYNC | TMR1CS | TMR1ON |
	T1CON = 0x31; // (00110001) -   1,   1/8 (250 )
} 

void timer1int(){ //    
	unsigned char term_reg, stop1, stop2; //   
//	CLRWDT //  watchdog
	timer1set(ON); //  
	term_reg = PORTB;
	term_reg &= 0x1F; //  
	stop1 = term_reg & stop_mask;
	stop2 = term_reg & stop_mask2;
	if(steps != 0 && isstep){ //    , 
		if(terminal_stops_motor && (stop1 != stop_bits) &&
				term_send){//  RB0, RB4
			steps = 1; //    ( steps    1)
			dir_before_term = dir_glob;
			dir_glob = -dir_glob; //    
		}
		step(dir_glob); //  
		steps--; //  -  
		if(steps == 0) //    9
			set_voltage(block);
	}
	//  
	//        
	//   -    
	if((term_reg != mode_mask) && terminal_flag){ // () ()
		if(term_send){ // ?
			if(async_msgs){ //    
				send9bit(TERMINALS); //     
				send9bit(term_reg); //    
			}
			term_send = 0;
			if(terminal_stops_motor && !isstep){ //   
				if(stop1 != stop_bits)// ,  . 1
					dpm(16);
				if(stop2 != stop_bits2)// -//-  2
					dpm(18);
			}
		}
	}
	else{ //   
		term_send = 1; //  /    
	}
}

void rot_step(char dir){ //     - 
	int newsteps;
	if(!getword()) return; //     - 
	if(term_send == 0){ //   ,   
		if(dir == dir_before_term){ //        
			term_send = 1; //        
			return;
		}
		total_steps = 0; //  - 
	}
	else dir_before_term = 0; //   
	newsteps = (d_H << 8) | d_L; //  
	if(s_add){
		if (dir != dir_glob){ //     
			if(steps < newsteps){ //     
				steps = newsteps - steps;
				dir_glob = dir; //    
			}
			else
				steps -= newsteps; //     - 
		}
		else steps += newsteps; //     
	}else{
		steps = newsteps; //       s_add == 0
		dir_glob = dir;
	}
	set_voltage(voltage); //  .  (..    - 9)
//	timer1set(ON); //  
}

void tot_steps(){ //    
	unsigned char ts_h, ts_l;
	if(!isstep){
		sendword(0, 0);
		return;
	}
	ts_h = total_steps >> 8;
	ts_l = total_steps & 0xFF;
	sendword(ts_h, ts_l);
}

void get_term_method(){ //    
/*         :
	  |TS|  A | stop_mask ||TF|  B | mode_mask |
	H/| 7| 6 5| 4 3 2 1 0 ||7 | 6 5| 4 3 2 1 0 |/L
	TS - terminal_stop_motor (1-  )
	TF - terminal_flag (1- )
	mode_mask -     
	stop_mask - 1-     1
	AB-stop_mask2 - 1-   2 
*/
	if(!getword()) return;
	terminal_stops_motor = d_H & 0x80;
	terminal_flag = d_L & 0x80 | terminal_stops_motor; //   
	stop_mask = d_H & 0x1F;
	stop_mask2 = ((d_H & 60) << 2) | (d_L & 60);
	mode_mask = d_L & 0x1F;
	stop_bits = mode_mask & stop_mask;
	stop_bits2 = mode_mask & stop_mask2;
}

void get_flags(){
	if(!getword()) return;
/*       :
	  | RESERVED u_blk | RESERVED  async_msgs |
	H/| 765432    1 0  | 7654321       0      |/L
	async_msgs -   (0 - , 1 - )
	u_blk -   (00 - , 01 - 9, 10 - 12, 11 - 24)
*/
	async_msgs = d_L & 1;
	block = (8 >> (d_H & 3)) & 7;
}

void  on_interrupt() __interrupt 0{ //  
	if(RCIF == 1){	//    USART
		if(get9bit() != OK) return;
		switch(cmd){
			case INIT:		if(!echo) send9bit(INIT); init(); break;
			case SET09V:		change_voltage(NINE); break;
			case SET12V:		change_voltage(TWELVE); break;
			case SET24V:		change_voltage(TWENTYFOUR); break;
			case STEP_LEFT:		step(LEFT); break;
			case STEP_RIGHT:	step(RIGHT); break;
			case DPM1L:			dpm(0); break;
			case DPM1R:			dpm(2); break;
			case DPM2L:			dpm(4); break;
			case DPM2R:			dpm(6); break;
			case DPM1L2L:		dpm(8); break;
			case DPM1L2R:		dpm(10); break;
			case DPM1R2L:		dpm(12); break;
			case DPM1R2R:		dpm(14); break;
			case DPM1_STOP:		dpm(16); break;
			case DPM2_STOP:		dpm(18); break;
			case ISSTEP:		isstep = 1; break;
			case ISNTSTEP:		isstep = 0; break;
			case STEP_L_NUM:	rot_step(LEFT); break;
			case STEP_R_NUM:	rot_step(RIGHT); break;
			case STEP_STOP:		steps = 0; dpm(20); break;
			case TOTAL_STEPS:	tot_steps(); break;
			case SET_TIMER:		if(getword()){
									TMR_H = d_H; TMR_L = d_L;
									timer1set(ON);}
								else if(echo) send9bit(ERR_CMD);
								break;
			case STOP_TIMER:	timer1set(OFF); break;
			case TMR_SETTINGS:	sendword(TMR_H, TMR_L); break;
//			case TEST:			test_flag = !test_flag; break;
			case TERM_METHOD:	get_term_method(); break;
			case RESERVED_FLAGS: get_flags(); break;
			case TERMINALS:		send9bit(PORTB);
			case NO_ECHO:		echo = 0;
			case NOT_ADD_STEPS:	s_add = 0;
			//default: send9bit(ERR_CMD); break;
		}
	}
	if(TMR1IF == 1) //    
		timer1int(); //  
}

void main(){ //  
	init();
	while(1){};//CLRWDT};
}

